#include <string>
#include "../se/files.h"

extern int requestId;

class SRMv1Type__RequestStatus;
class SRMv1Type__RequestFileStatus;
class ArrayOfstring;
class ArrayOflong;
class ArrayOfboolean;
struct soap;

class AuthUser;

SRMv1Type__RequestStatus* soap_error_SRMv1Type__RequestStatus(struct soap *sp,int n,const char* reason = NULL);

void convert_checksum(struct soap *sp,const std::string& checksum,char** checksumType,char** checksumValue);

SEFiles::iterator find_file(const std::string& id,SEFiles* files,AuthUser& identity,int acl_mask);

SEFiles::iterator get_file(struct soap *sp,const std::string& id,SEFiles* files,SRMv1Type__RequestFileStatus *f_status,AuthUser& identity,int acl_mask);

std::string get_ID_from_TURL(const char* turl,const char* service);

std::string get_ID_from_SURL(const char* surl,const char* service,bool* isshort = NULL);

std::string strip_SURL_to_ID(const char* surl,const char* service,bool* isshort = NULL);

bool array_is_empty(ArrayOfstring* a);

bool array_is_empty(ArrayOflong* a);

bool array_is_empty(ArrayOfboolean* a);

const char* check_protocols(ArrayOfstring* Protocols);

void get_protocols(ArrayOfstring* Protocols);

std::string make_SURL(const std::string& service_url,const std::string& id);

std::string make_SURL_short(const std::string& service_url,const std::string& id);

std::string make_TURL(const std::string& service_url,const std::string& id);

