#include "../../std.h"

#include <string>

#include "../../misc/log_time.h"
//#include "../../misc/escaped.h"
//#include "../../misc/time_utils.h"

// one more hack
#undef SOAP_FMAC3
#define WITH_NOGLOBAL
#define SOAP_FMAC3 static
// For namespaces table
#include "srm2_soap.nsmap"
#include "srm2_soapC.cpp"
#include "srm2_soapClient.cpp"
#include "srm2_soapServer.cpp"

#include "srm_url.h"
#include "srm_request.h"

#include "srm_proxy.h"


// --------------------------------------------------------------
// Methods

int SRMv2__srmLs(struct soap* sp, SRMv2__srmLsRequest *req, struct SRMv2__srmLsResponse_ &resp) {
  HTTP_SRM_Proxy* it = (HTTP_SRM_Proxy*)(sp->user);
  return SOAP_OK;
}


int SRMv2__srmRm(struct soap* sp, SRMv2__srmRmRequest *req, struct SRMv2__srmRmResponse_ &resp) {
  HTTP_SRM_Proxy* it = (HTTP_SRM_Proxy*)(sp->user);
  return SOAP_OK;
}
 
 
int SRMv2__srmSetPermission(struct soap* sp, SRMv2__srmSetPermissionRequest *req, struct SRMv2__srmSetPermissionResponse_ &resp) {
  HTTP_SRM_Proxy* it = (HTTP_SRM_Proxy*)(sp->user);
  return SOAP_OK;
}

int SRMv2__srmRmdir(struct soap* sp, SRMv2__srmRmdirRequest *req, struct SRMv2__srmRmdirResponse_ &resp) {
  HTTP_SRM_Proxy* it = (HTTP_SRM_Proxy*)(sp->user);
  return SOAP_OK;
}

// --------------------------------------------------------------
// Non-supported methods

int SRMv2__srmRemoveFiles(struct soap* sp, SRMv2__srmRemoveFilesRequest *req, struct SRMv2__srmRemoveFilesResponse_ &resp) {
  resp.srmRemoveFilesResponse = soap_new_SRMv2__srmRemoveFilesResponse(sp,-1);
  resp.srmRemoveFilesResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmRemoveFilesResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}

int SRMv2__srmReserveSpace(struct soap* sp, SRMv2__srmReserveSpaceRequest *req, struct SRMv2__srmReserveSpaceResponse_ &resp) {
  resp.srmReserveSpaceResponse = soap_new_SRMv2__srmReserveSpaceResponse(sp,-1);
  resp.srmReserveSpaceResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmReserveSpaceResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}

int SRMv2__srmReleaseSpace(struct soap* sp, SRMv2__srmReleaseSpaceRequest *req, struct SRMv2__srmReleaseSpaceResponse_ &resp) {
  resp.srmReleaseSpaceResponse = soap_new_SRMv2__srmReleaseSpaceResponse(sp,-1);
  resp.srmReleaseSpaceResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmReleaseSpaceResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmUpdateSpace(struct soap* sp, SRMv2__srmUpdateSpaceRequest *req, struct SRMv2__srmUpdateSpaceResponse_ &resp) {
  resp.srmUpdateSpaceResponse = soap_new_SRMv2__srmUpdateSpaceResponse(sp,-1);
  resp.srmUpdateSpaceResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmUpdateSpaceResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmCompactSpace(struct soap* sp, SRMv2__srmCompactSpaceRequest *req, struct SRMv2__srmCompactSpaceResponse_ &resp) {
  resp.srmCompactSpaceResponse = soap_new_SRMv2__srmCompactSpaceResponse(sp,-1);
  resp.srmCompactSpaceResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmCompactSpaceResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmGetSpaceMetaData(struct soap* sp, SRMv2__srmGetSpaceMetaDataRequest *req, struct SRMv2__srmGetSpaceMetaDataResponse_ &resp) {
  resp.srmGetSpaceMetaDataResponse = soap_new_SRMv2__srmGetSpaceMetaDataResponse(sp,-1);
  resp.srmGetSpaceMetaDataResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmGetSpaceMetaDataResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmChangeFileStorageType(struct soap* sp, SRMv2__srmChangeFileStorageTypeRequest *req, struct SRMv2__srmChangeFileStorageTypeResponse_ &resp) {
  resp.srmChangeFileStorageTypeResponse = soap_new_SRMv2__srmChangeFileStorageTypeResponse(sp,-1);
  resp.srmChangeFileStorageTypeResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmChangeFileStorageTypeResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmGetSpaceToken(struct soap* sp, SRMv2__srmGetSpaceTokenRequest *req, struct SRMv2__srmGetSpaceTokenResponse_ &resp) {
  resp.srmGetSpaceTokenResponse = soap_new_SRMv2__srmGetSpaceTokenResponse(sp,-1);
  resp.srmGetSpaceTokenResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmGetSpaceTokenResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmReassignToUser(struct soap* sp, SRMv2__srmReassignToUserRequest *req, struct SRMv2__srmReassignToUserResponse_ &resp) {
  resp.srmReassignToUserResponse = soap_new_SRMv2__srmReassignToUserResponse(sp,-1);
  resp.srmReassignToUserResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmReassignToUserResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmCheckPermission(struct soap* sp, SRMv2__srmCheckPermissionRequest *req, struct SRMv2__srmCheckPermissionResponse_ &resp) {
  resp.srmCheckPermissionResponse = soap_new_SRMv2__srmCheckPermissionResponse(sp,-1);
  resp.srmCheckPermissionResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmCheckPermissionResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmMkdir(struct soap* sp, SRMv2__srmMkdirRequest *req, struct SRMv2__srmMkdirResponse_ &resp) {
  resp.srmMkdirResponse = soap_new_SRMv2__srmMkdirResponse(sp,-1);
  resp.srmMkdirResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmMkdirResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmMv(struct soap* sp, SRMv2__srmMvRequest *req, struct SRMv2__srmMvResponse_ &resp) {
  resp.srmMvResponse = soap_new_SRMv2__srmMvResponse(sp,-1);
  resp.srmMvResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmMvResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmPrepareToPut(struct soap* sp, SRMv2__srmPrepareToPutRequest *req, struct SRMv2__srmPrepareToPutResponse_ &resp) {
  resp.srmPrepareToPutResponse = soap_new_SRMv2__srmPrepareToPutResponse(sp,-1);
  resp.srmPrepareToPutResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmPrepareToPutResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmPrepareToGet(struct soap* sp, SRMv2__srmPrepareToGetRequest *req, struct SRMv2__srmPrepareToGetResponse_ &resp) {
  resp.srmPrepareToGetResponse = soap_new_SRMv2__srmPrepareToGetResponse(sp,-1);
  resp.srmPrepareToGetResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmPrepareToGetResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmCopy(struct soap* sp, SRMv2__srmCopyRequest *req, struct SRMv2__srmCopyResponse_ &resp) {
  resp.srmCopyResponse = soap_new_SRMv2__srmCopyResponse(sp,-1);
  resp.srmCopyResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmCopyResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmReleaseFiles(struct soap* sp, SRMv2__srmReleaseFilesRequest *req, struct SRMv2__srmReleaseFilesResponse_ &resp) {
  resp.srmReleaseFilesResponse = soap_new_SRMv2__srmReleaseFilesResponse(sp,-1);
  resp.srmReleaseFilesResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmReleaseFilesResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmPutDone(struct soap* sp, SRMv2__srmPutDoneRequest*, struct SRMv2__srmPutDoneResponse_ &resp) {
  resp.srmPutDoneResponse = soap_new_SRMv2__srmPutDoneResponse(sp,-1);
  resp.srmPutDoneResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmPutDoneResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmAbortRequest(struct soap* sp, SRMv2__srmAbortRequestRequest *req, struct SRMv2__srmAbortRequestResponse_ &resp) {
  resp.srmAbortRequestResponse = soap_new_SRMv2__srmAbortRequestResponse(sp,-1);
  resp.srmAbortRequestResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmAbortRequestResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmAbortFiles(struct soap* sp, SRMv2__srmAbortFilesRequest *req, struct SRMv2__srmAbortFilesResponse_ &resp) {
  resp.srmAbortFilesResponse = soap_new_SRMv2__srmAbortFilesResponse(sp,-1);
  resp.srmAbortFilesResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmAbortFilesResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmSuspendRequest(struct soap* sp, SRMv2__srmSuspendRequestRequest *req, struct SRMv2__srmSuspendRequestResponse_ &resp) {
  resp.srmSuspendRequestResponse = soap_new_SRMv2__srmSuspendRequestResponse(sp,-1);
  resp.srmSuspendRequestResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmSuspendRequestResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmResumeRequest(struct soap* sp, SRMv2__srmResumeRequestRequest *req, struct SRMv2__srmResumeRequestResponse_ &resp) {
  resp.srmResumeRequestResponse = soap_new_SRMv2__srmResumeRequestResponse(sp,-1);
  resp.srmResumeRequestResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmResumeRequestResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmStatusOfGetRequest(struct soap* sp, SRMv2__srmStatusOfGetRequestRequest *req, struct SRMv2__srmStatusOfGetRequestResponse_ &resp) {
  resp.srmStatusOfGetRequestResponse = soap_new_SRMv2__srmStatusOfGetRequestResponse(sp,-1);
  resp.srmStatusOfGetRequestResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmStatusOfGetRequestResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmStatusOfPutRequest(struct soap* sp, SRMv2__srmStatusOfPutRequestRequest *req, struct SRMv2__srmStatusOfPutRequestResponse_ &resp) {
  resp.srmStatusOfPutRequestResponse = soap_new_SRMv2__srmStatusOfPutRequestResponse(sp,-1);
  resp.srmStatusOfPutRequestResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmStatusOfPutRequestResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmStatusOfCopyRequest(struct soap* sp, SRMv2__srmStatusOfCopyRequestRequest *req, struct SRMv2__srmStatusOfCopyRequestResponse_ &resp) {
  resp.srmStatusOfCopyRequestResponse = soap_new_SRMv2__srmStatusOfCopyRequestResponse(sp,-1);
  resp.srmStatusOfCopyRequestResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmStatusOfCopyRequestResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmGetRequestSummary(struct soap* sp, SRMv2__srmGetRequestSummaryRequest *req, struct SRMv2__srmGetRequestSummaryResponse_ &resp) {
  resp.srmGetRequestSummaryResponse = soap_new_SRMv2__srmGetRequestSummaryResponse(sp,-1);
  resp.srmGetRequestSummaryResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmGetRequestSummaryResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmExtendFileLifeTime(struct soap* sp, SRMv2__srmExtendFileLifeTimeRequest *req, struct SRMv2__srmExtendFileLifeTimeResponse_ &resp) {
  resp.srmExtendFileLifeTimeResponse = soap_new_SRMv2__srmExtendFileLifeTimeResponse(sp,-1);
  resp.srmExtendFileLifeTimeResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmExtendFileLifeTimeResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}


int SRMv2__srmGetRequestID(struct soap* sp, SRMv2__srmGetRequestIDRequest *req, struct SRMv2__srmGetRequestIDResponse_ &resp) {
  resp.srmGetRequestIDResponse = soap_new_SRMv2__srmGetRequestIDResponse(sp,-1);
  resp.srmGetRequestIDResponse->returnStatus=soap_new_SRMv2__TReturnStatus(sp,-1);
  resp.srmGetRequestIDResponse->returnStatus->statusCode=SRMv2__TStatusCode__SRM_USCORENOT_USCORESUPPORTED;
  return SOAP_OK;
}

